package com.ejie.ab79.service.procedimientos;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab79.dao.procedimientos.DireccionesDao;
import com.ejie.ab79.model.Inspectores;
import com.ejie.ab79.model.REST.servicioWeb.Direccion;
import com.ejie.ab79.model.procedimientos.Direcciones;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRequestDto;
import com.ejie.x38.dto.TableResponseDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * DireccionesServiceImpl  
 * 
 *  
 */

@Service(value = "direccionesService")
public class DireccionesServiceImpl implements DireccionesService {

	@Autowired
	private DireccionesDao direccionesDao;

	/**
	 * Finds a single row in the Direcciones table.
	 *
	 * @param direcciones
	 *            Direcciones
	 * @return Direcciones
	 */
	public Direcciones find(Direcciones direcciones) {
		return (Direcciones) this.direccionesDao.find(direcciones);
	}

	/**
	 * Deletes a single row in the Direcciones table.
	 *
	 * @param direcciones
	 *            Direcciones
	 */
	@Transactional(rollbackFor = Throwable.class)
	public void remove(Direcciones direcciones) {
		this.direccionesDao.remove(direcciones);
	}

	/**
	 * Finds a list of rows in the Direcciones table.
	 *
	 * @param direcciones
	 *            Direcciones
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<Direcciones>
	 */
	public List<Direcciones> findAll(Direcciones direcciones, TableRequestDto tableRequestDto) {
		return (List<Direcciones>) this.direccionesDao.findAll(direcciones, tableRequestDto);
	}

	@Override
	public List<Direccion> findByInspector(Inspectores inspector) {
		return (List<Direccion>) this.direccionesDao.findByInspector(inspector);
	}

	/**
	 * Finds rows in the Direcciones table using like.
	 *
	 * @param direcciones
	 *            Direcciones
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<Direcciones>
	 */
	public List<Direcciones> findAllLike(Direcciones direcciones, TableRequestDto tableRequestDto, Boolean startsWith) {
		return (List<Direcciones>) this.direccionesDao.findAllLike(direcciones, tableRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the Direcciones table.
	 *
	 * @param filterDirecciones
	 *            Direcciones
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	public void removeMultiple(Direcciones filterDirecciones, TableRequestDto tableRequestDto, Boolean startsWith) {
		this.direccionesDao.removeMultiple(filterDirecciones, tableRequestDto, startsWith);
	}

	/**
	 * Filter method in the Direcciones table.
	 *
	 * @param filterDirecciones
	 *            Direcciones
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return TableResponseDto<Direcciones>
	 */
	public TableResponseDto<Direcciones> filter(Direcciones filterDirecciones, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		List<Direcciones> listaDirecciones = this.direccionesDao.findAllLike(filterDirecciones, tableRequestDto, false);
		Long recordNum = this.direccionesDao
				.findAllLikeCount(filterDirecciones != null ? filterDirecciones : new Direcciones(), false);

		TableResponseDto<Direcciones> usuarioDto = new TableResponseDto<Direcciones>(tableRequestDto, recordNum,
				listaDirecciones);

		if (tableRequestDto.getMultiselection().getSelectedIds() != null) {
			List<TableRowDto<Direcciones>> reorderSelection = this.direccionesDao.reorderSelection(filterDirecciones,
					tableRequestDto, startsWith);
			usuarioDto.setReorderedSelection(reorderSelection);
			usuarioDto.addAdditionalParam("reorderedSelection", reorderSelection);
			usuarioDto.addAdditionalParam("selectedAll", tableRequestDto.getMultiselection().getSelectedAll());
		}
		if (tableRequestDto.getSeeker().getSelectedIds() != null) {
			tableRequestDto.setMultiselection(tableRequestDto.getSeeker());
			List<TableRowDto<Direcciones>> reorderSeeker = this.direccionesDao.reorderSelection(filterDirecciones,
					tableRequestDto, startsWith);
			usuarioDto.setReorderedSeeker(reorderSeeker);
			usuarioDto.addAdditionalParam("reorderedSeeker", reorderSeeker);
		}
		return usuarioDto;
	}

	/**
	 * Searches rows in the Direcciones table.
	 *
	 * @param filterDirecciones
	 *            Direcciones
	 * @param searchDirecciones
	 *            Direcciones
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<Direcciones>>
	 */
	public List<TableRowDto<Direcciones>> search(Direcciones filterDirecciones, Direcciones searchDirecciones,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		return this.direccionesDao.search(filterDirecciones, searchDirecciones, tableRequestDto, startsWith);
	}

	/**
	 * Reorder the selection made in Direcciones table.
	 *
	 * @param filterDirecciones
	 *            Direcciones
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return Object
	 */
	public Object reorderSelection(Direcciones filterDirecciones, TableRequestDto tableRequestDto, Boolean startsWith) {
		return this.direccionesDao.reorderSelection(filterDirecciones, tableRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the Direcciones table.
	 *
	 * @param filterDirecciones
	 *            Direcciones
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return TableResponseDto<JerarquiaDto<Direcciones>>
	 */
	public TableResponseDto<JerarquiaDto<Direcciones>> jerarquia(Direcciones filterDirecciones,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		List<JerarquiaDto<Direcciones>> listaDirecciones = this.direccionesDao.findAllLikeJerarquia(filterDirecciones,
				tableRequestDto);
		Long recordNum = this.direccionesDao.findAllLikeCountJerarquia(filterDirecciones, tableRequestDto);
		return new TableResponseDto<JerarquiaDto<Direcciones>>(tableRequestDto, recordNum, listaDirecciones);
	}

	/**
	 * Finder method for siblings rows in the hierarchical the Direcciones
	 * table.
	 *
	 * @param filterDirecciones
	 *            Direcciones
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return TableResponseDto<JerarquiaDto<Direcciones>>
	 */
	public TableResponseDto<JerarquiaDto<Direcciones>> jerarquiaChildren(Direcciones filterDirecciones,
			TableRequestDto tableRequestDto) {
		TableResponseDto<JerarquiaDto<Direcciones>> tableResponseDto = new TableResponseDto<JerarquiaDto<Direcciones>>();
		tableResponseDto.addAdditionalParam(TableResponseDto.CHILDREN,
				this.direccionesDao.findAllChild(filterDirecciones, tableRequestDto));
		return tableResponseDto;
	}

	/**
	 * Exporta Datos al clipBoard
	 *
	 */
	public List<Direcciones> getMultiple(Direcciones filterDirecciones, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		return this.direccionesDao.getMultiple(filterDirecciones, tableRequestDto, startsWith);
	}

}
